> ## Documentation Index
> Fetch the complete documentation index at: https://www.c1.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Rotate Secret

> RotateSecret issues a new client secret for a static client and returns it
 once. The client keeps its client_id, redirect URIs, and grants.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples post /api/v1/iam/external_oauth_clients/rotate-secret
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/iam/external_oauth_clients/rotate-secret:
    post:
      tags:
        - External OAuth Client
      summary: Rotate Secret
      description: >-
        RotateSecret issues a new client secret for a static client and returns
        it
         once. The client keeps its client_id, redirect URIs, and grants.
      operationId: c1.api.iam.v1.ExternalOAuthClientService.RotateSecret
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/c1.api.iam.v1.ExternalOAuthClientServiceRotateSecretRequest
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/c1.api.iam.v1.ExternalOAuthClientServiceRotateSecretResponse
          description: Successful response
components:
  schemas:
    c1.api.iam.v1.ExternalOAuthClientServiceRotateSecretRequest:
      description: The ExternalOAuthClientServiceRotateSecretRequest message.
      properties:
        clientId:
          description: The clientId field.
          type: string
      title: External O Auth Client Service Rotate Secret Request
      type: object
      x-speakeasy-name-override: ExternalOAuthClientServiceRotateSecretRequest
    c1.api.iam.v1.ExternalOAuthClientServiceRotateSecretResponse:
      description: The ExternalOAuthClientServiceRotateSecretResponse message.
      properties:
        clientSecret:
          description: Revealed once, like Create.
          type: string
      title: External O Auth Client Service Rotate Secret Response
      type: object
      x-speakeasy-name-override: ExternalOAuthClientServiceRotateSecretResponse
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````